<script lang="ts">
import Vue from "vue";
import { SlpButton, SlpTypography, SlpIcon } from "slippers-ui";
import { debounce, DebouncedFunc } from "lodash-es";

import ChevronIcon from "../../assets/chevron.vue";
import TimeIsMoneyIcon from "../../assets/time-is-money.vue";
import PricingPlansIcon from "../../assets/pricing-plans.vue";
import NavCard from "../Common/nav-card.vue";
import NavDropdownFooter from "../Common/nav-dropdown-footer.vue";

export default Vue.extend({
  name: "NavigationDropdown",
  components: {
    SlpButton,
    ChevronIcon,
    TimeIsMoneyIcon,
    PricingPlansIcon,
    SlpTypography,
    SlpIcon,
    NavCard,
    NavDropdownFooter,
  },
  props: {
    itemData: {
      required: false,
      type: Object,
      default: () => ({}),
    },
    showDropdown: {
      default: false,
      type: Boolean,
    },
  },
  data() {
    return {
      resizeDebounce: (() => ({})) as DebouncedFunc<any>,
    };
  },
  created() {
    this.resizeDebounce = debounce(this.calculateBoundaries, 18);
  },
  mounted() {
    this.$nextTick(() => {
      this.calculateBoundaries();
      window.addEventListener("resize", this.resizeDebounce);
    });
  },
  beforeDestroy() {
    window.removeEventListener("resize", this.resizeDebounce);
  },
  methods: {
    resetOffset() {
      const popover = this.$refs.popover as HTMLElement;
      const classList = popover.classList;

      if (classList.value.includes("left")) {
        popover.style.left = `0`;
      } else if (classList.value.includes("right")) {
        popover.style.left = `70px`;
      } else {
        popover.style.left = `50%`;
      }
    },
    calculateBoundaries() {
      this.resetOffset();
      const bodyRect = document.body.getBoundingClientRect();
      const popover = this.$refs.popover as HTMLElement;
      const rect = popover.getBoundingClientRect();
      const offset = bodyRect.right - rect.right;

      if (offset < 0) {
        popover.style.left = `${offset - 8}px`;
      }
    },
  },
});
</script>

<template>
  <div class="navigation-dropdown">
    <SlpButton
      class="navigation-dropdown__button"
      variant="ghost"
      :href="itemData.href"
      v-bind="itemData.headerGa"
      :title="itemData.text"
      :name="itemData.text"
    >
      <slot name="buttonContent">{{ itemData.text }}</slot>
      <!-- If the #buttonContent slot is not defined, the data.text property is used by default-->
      <ChevronIcon v-if="itemData.categories" direction="down" />
    </SlpButton>
    <!-- The v-show directive needs to be used for the popover because we need to have
          all HTML elements in the DOM at all time for SEO purposes -->
    <div
      v-show="itemData.categories || $slots.default"
      ref="popover"
      class="navigation-dropdown__popover navigation-dropdown__popover--hidden navigation-dropdown__popover--center"
      :class="[
        itemData.placement &&
          `navigation-dropdown__popover--${itemData.placement}`,
        { 'navigation-dropdown__popover--show': showDropdown },
        { 'with-footer': itemData.footer },
        { 'no-border': itemData.primarySideSection },
      ]"
    >
      <slot></slot>
      <div
        class="navigation-dropdown__main"
        :class="[
          {
            'navigation-dropdown__main--side-section':
              itemData.primarySideSection,
          },
          {
            'navigation-dropdown__main--solutions-update':
              itemData.layout === 'Solutions (Update)',
          },
        ]"
        v-show="itemData.categories"
        v-if="
          !itemData.layout ||
          itemData.layout.toLowerCase() === 'default' ||
          itemData.layout.toLowerCase() === 'solutions (update)'
        "
      >
        <div
          :style="{ columns: itemData.columns }"
          :class="{ 'navigation-dropdown__main--w-columns': itemData.columns }"
        >
          <div
            class="navigation-dropdown__categories"
            v-for="category of itemData.categories"
            :key="category.title"
            :class="{
              'navigation-dropdown__categories--mb': category.hasBottomMargin,
            }"
          >
            <div v-if="category.items.length" class="slp-mt-8">
              <SlpTypography
                tag="span"
                variant="body2-bold"
                class="slp-color-accent-500 slp-mb-8 navigation-dropdown__category-title"
              >
                <span v-html="category.title" />
              </SlpTypography>
              <div
                class="slp-flex"
                v-for="innerCat of category.items"
                :key="innerCat.text"
              >
                <a
                  class="navigation-dropdown__popover-link"
                  :href="innerCat.href"
                  v-bind="innerCat.headerGa"
                >
                  <SlpTypography tag="span" variant="body2"
                    >{{ innerCat.text }}
                  </SlpTypography>
                </a>
              </div>
            </div>
            <a
              v-else
              class="navigation-dropdown__popover-link"
              :href="category.href"
              v-bind="category.headerGa"
            >
              <SlpTypography tag="span" variant="body2"
                >{{ category.text }}
              </SlpTypography>
            </a>
          </div>
        </div>
        <SlpButton
          v-if="itemData.bottomLink"
          class="navigation-dropdown__bottom-link"
          variant="tertiary"
          :href="itemData.bottomLink.href"
          v-bind="itemData.bottomLink.headerGa"
        >
          {{ itemData.bottomLink.text }}
          <SlpIcon
            class="slp-ml-8"
            name="chevron-lg-right"
            variant="product"
            alt="Chevron Right Icon"
          />
        </SlpButton>
      </div>
      <div class="navigation-dropdown__main" v-else>
        <div
          :style="{ gridTemplateColumns: `repeat(${itemData.columns}, 300px)` }"
          class="nav-card-grid"
          :class="{
            separators: itemData.categories.some((item) => !item.ctaText),
          }"
        >
          <NavCard
            v-for="category of itemData.categories"
            :key="category.title"
            v-bind="category"
          />
          <SlpButton
            v-if="itemData.bottomLink"
            class="navigation-dropdown__bottom-link"
            variant="tertiary"
            :href="itemData.bottomLink.href"
            v-bind="itemData.bottomLink.headerGa"
          >
            {{ itemData.bottomLink.text }}
            <SlpIcon
              class="slp-ml-8"
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </div>
      </div>
      <!-- RESOURCES DROPDOWN SIDE SECTION -->
      <a
        v-if="itemData.primarySideSection && !itemData.secondarySideSection"
        class="navigation-dropdown__side-section navigation-dropdown__side-section--border-left"
        :href="itemData.primarySideSection.primaryLink.href"
        v-bind="itemData.primarySideSection.primaryLink.headerGa"
      >
        <div>
          <SlpTypography
            v-if="itemData.primarySideSection.title"
            tag="span"
            variant="body2-bold"
            class="slp-mb-8"
          >
            {{ itemData.primarySideSection.title }}
          </SlpTypography>
          <div class="navigation-dropdown__image">
            <img
              v-if="itemData.primarySideSection.image"
              :src="itemData.primarySideSection.image.url"
              :alt="itemData.primarySideSection.image.altText"
              loading="lazy"
            />
          </div>
        </div>
        <SlpTypography tag="p" variant="body1-bold" class="slp-mb-8">
          {{ itemData.primarySideSection.text }}
        </SlpTypography>
        <SlpButton
          class="navigation-dropdown__side-link"
          variant="tertiary"
          :href="itemData.primarySideSection.primaryLink.href"
          v-bind="itemData.primarySideSection.primaryLink.headerGa"
        >
          {{ itemData.primarySideSection.primaryLink.text }}
          <SlpIcon
            name="arrow-right"
            variant="product"
            alt="Arrow Right Icon"
          />
        </SlpButton>
      </a>
      <!-- SOLUTIONS DROPDOWN SIDE SECTION -->
      <div v-if="itemData.primarySideSection && itemData.secondarySideSection">
        <div
          class="navigation-dropdown__side-section"
          v-bind="itemData.primarySideSection.primaryLink.headerGa"
        >
          <div class="navigation-dropdown__icon">
            <TimeIsMoneyIcon />
          </div>
          <SlpTypography tag="span" variant="body3-bold" class="slp-mb-8">
            {{ itemData.primarySideSection.title }}
          </SlpTypography>
          <SlpTypography tag="p" variant="body3" class="slp-mb-8">
            {{ itemData.primarySideSection.text }}
          </SlpTypography>
          <SlpButton
            v-if="itemData.primarySideSection.primaryLink"
            class="navigation-dropdown__side-link navigation-dropdown__side-link-small"
            variant="tertiary"
            :href="itemData.primarySideSection.primaryLink.href"
            v-bind="itemData.primarySideSection.primaryLink.headerGa"
          >
            {{ itemData.primarySideSection.primaryLink.text }}
            <SlpIcon
              name="chevron-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </div>
        <div
          class="navigation-dropdown__side-section"
          :href="itemData.secondarySideSection.primaryLink.href"
          v-bind="itemData.secondarySideSection.primaryLink.headerGa"
        >
          <div class="navigation-dropdown__icon">
            <PricingPlansIcon />
          </div>
          <SlpTypography tag="span" variant="body3-bold" class="slp-mb-8">
            {{ itemData.secondarySideSection.title }}
          </SlpTypography>
          <SlpTypography tag="p" variant="body3" class="slp-mb-8">
            {{ itemData.secondarySideSection.text }}
          </SlpTypography>
          <SlpButton
            class="navigation-dropdown__side-link navigation-dropdown__side-link-small slp-mb-8"
            variant="tertiary"
            :href="itemData.secondarySideSection.primaryLink.href"
            v-bind="itemData.secondarySideSection.primaryLink.headerGa"
          >
            {{ itemData.secondarySideSection.primaryLink.text }}
            <SlpIcon
              name="chevron-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
          <SlpButton
            v-if="itemData.secondarySideSection.secondaryLink"
            class="navigation-dropdown__side-link navigation-dropdown__side-link-small slp-mb-16"
            variant="tertiary"
            :href="itemData.secondarySideSection.secondaryLink.href"
            v-bind="itemData.secondarySideSection.secondaryLink.headerGa"
          >
            {{ itemData.secondarySideSection.secondaryLink.text }}
            <SlpIcon
              name="chevron-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </div>
      </div>
      <NavDropdownFooter
        v-if="itemData.footer"
        v-bind="itemData.footer.fields"
      />
    </div>
  </div>
</template>

<style lang="scss">
$popover-width: 170px;

.navigation-dropdown {
  position: relative;
  display: inline-block;
  padding-bottom: $spacing-16;
  margin-bottom: -$spacing-16;

  &:hover &__popover {
    visibility: visible;
    opacity: 1;
  }

  &:hover &__button {
    color: $color-text-300;

    svg {
      display: block;
    }
  }

  &__button {
    position: relative;
    color: $color-text-200;
    transition: all 0.3s ease-in-out;

    &:hover {
      color: $color-text-300;

      svg {
        display: block;
      }
    }

    svg {
      display: none;
      position: absolute;
      bottom: -4px;
      left: calc(50% - 8px);
    }
  }

  &__popover {
    top: 50px;
    position: absolute;
    min-width: $popover-width;
    background-color: white;
    z-index: 1;
    border: 1px solid $color-surface-300;
    border-radius: 4px;
    box-shadow: 0 8px 50px -16px rgba(209, 208, 211, 0.5);
    transition: visibility 0s, opacity 0.15s ease-in-out;
    display: flex;

    &--center {
      transform: translateX(-50%);
      left: 50%;
    }

    &--hidden {
      visibility: hidden;
      opacity: 0;
    }

    &--left {
      transform: translateX(0);
      left: 0;
    }

    &--right {
      transform: translateX(-100%);
      left: 70px;
    }

    &--show {
      visibility: visible;
      opacity: 1;
    }
  }

  &__categories {
    display: flex;
    flex-direction: column;
    margin: 0 $spacing-4;
    min-width: $popover-width;
    break-inside: avoid;

    @media (min-width: $breakpoint-lg) {
      margin: 0;
    }
    @media (min-width: $breakpoint-xl) {
      margin: 0 $spacing-16;
    }

    &--mb {
      margin-bottom: $spacing-24 !important;
    }
  }

  &__popover-link {
    padding: $spacing-8 0;
    color: $color-text-300 !important;
    white-space: nowrap;

    &:hover {
      color: $color-text-link-100 !important;
    }
  }

  &__bottom-link {
    padding-bottom: 0 !important;

    @media (min-width: $breakpoint-xl) {
      padding-left: $spacing-16 !important;
      padding-bottom: $spacing-16 !important;
    }
  }

  &__main {
    padding: $spacing-24 $spacing-16;
    display: flex;
    flex-direction: column;
    justify-content: space-between;

    &--side-section {
      border: 1px solid #d1d0d3;
      border-radius: $spacing-4 0 0 $spacing-4;
    }

    @media (min-width: $breakpoint-xl) {
      padding: $spacing-24 $spacing-8;
    }

    &--w-columns {
      @media (max-width: $breakpoint-2xl) {
        margin-right: -50px;
      }
      @media (max-width: $breakpoint-xl) {
        margin-right: -80px;
      }
    }
    &.navigation-dropdown__main--solutions-update {
      padding: 24px;
      .navigation-dropdown__popover-link {
        padding: 12px 0;
      }
      .navigation-dropdown__main--w-columns {
        margin-right: 0 !important;
      }
      .navigation-dropdown__category-title {
        display: block;
        margin-bottom: 10px;
      }
      .navigation-dropdown__bottom-link {
        font-size: 16px;
        padding: 11px 0 0 4px !important;
        margin-top: 20px;

        .slp-icon {
          height: 12px !important;
          width: 12px !important;
          position: relative;
          svg {
            position: absolute;
            top: 0;
            left: 0;
          }
        }
        @media (min-width: $breakpoint-lg) {
          padding: 11px 0 0 0 !important;
        }
        @media (min-width: $breakpoint-xl) {
          padding: 11px 0 0 16px !important;
        }
      }

      + .nav-footer {
        padding: 24px;
        @media (min-width: $breakpoint-xl) {
          padding: 24px 40px 32px;
        }
      }
    }
  }

  &__side-section {
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    padding: $spacing-24;
    background-color: #2f2a6b;
    border-radius: 4px;
    white-space: normal;
    color: white;

    &--border-left {
      border-radius: 0 $spacing-4 $spacing-4 0;
    }

    h5,
    p {
      color: $color-text-50;
      font-weight: 400 !important;
    }

    &:hover {
      transition: all 0.3s ease-in-out;
    }
  }

  &__image,
  &__logo {
    max-width: 200px;
    margin-bottom: $spacing-16;
    width: 200px;
    height: 160px;

    @media (min-width: $breakpoint-xl) {
      width: 239px;
      max-width: 239px;
    }

    img {
      width: 100%;
      height: 100%;
    }
  }

  &__logo {
    border-radius: $border-radius-4 $border-radius-4 50px $border-radius-4;
    background: $color-surface-50;
    padding: 12px;
    box-sizing: border-box;

    img {
      object-fit: contain;
    }
  }

  &__icon {
    max-width: 200px;
    margin-bottom: $spacing-16;
    width: 200px;

    @media (min-width: $breakpoint-xl) {
      width: 239px;
      max-width: 239px;
    }

    img {
      border-bottom-right-radius: 50px;
      width: 100%;
      height: 100%;
      object-fit: cover;
    }
  }

  &__side-link {
    color: $color-surface-50 !important;
    padding-left: 0 !important;
    padding-bottom: 0 !important;
    transition: none !important;
    text-align: left !important;

    & > * {
      transition: none !important;
    }

    &-small {
      font-size: 14px !important;
    }

    &:hover {
      text-decoration-color: $color-surface-50 !important;
    }
  }

  &__footer {
    background-color: $color-surface-800;
    padding: $spacing-24 $spacing-32 $spacing-32 $spacing-32;
  }
}
.nav-card-grid {
  display: grid;
  grid-template-columns: repeat(3, 300px);
  gap: 1px;
  &.separators {
    background-color: $color-surface-200;
  }
}
.with-footer {
  display: flex;
  flex-direction: column;
}

.no-border {
  border: none;
  border-radius: 4px 4px 6px 4px;
}
</style>
